]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
rust-cfg-if: New package.
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
f06578af 20# Copyright (C) 2007-2021 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
255273a3 28VERSION="2.27" # Version number
8c1cc06d 29CORE="164" # Core Level (Filename)
e8ee3199
AF
30SLOGAN="www.ipfire.org" # Software slogan
31CONFIG_ROOT=/var/ipfire # Configuration rootdir
e8ee3199 32MAX_RETRIES=1 # prefetch/check loop
305a7b38 33BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 34KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
35
36# Information from Git
37GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38GIT_TAG="$(git tag | tail -1)" # Git Tag
39GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 40
5e7ba4f4 41TOOLCHAINVER=20210701
03ad5f93 42
178eaf31
AF
43# use multicore and max compression
44ZSTD_OPT="-T0 --ultra -22"
d66e6fa8 45
69a6ec55
MT
46###############################################################################
47#
48# Beautifying variables & presentation & input output interface
49#
50###############################################################################
51
f9783277
MT
52# Remember if the shell is interactive or not
53if [ -t 0 ] && [ -t 1 ]; then
54 INTERACTIVE=true
55else
56 INTERACTIVE=false
57fi
58
401a1edc
MT
59# Sets or adjusts pretty formatting variables
60resize_terminal() {
61 ## Screen Dimentions
62 # Find current screen size
63 COLUMNS=$(tput cols)
64
65 # When using remote connections, such as a serial port, stty size returns 0
66 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
67 COLUMNS=80
68 fi
69a6ec55 69
401a1edc
MT
70 # Measurements for positioning result messages
71 OPTIONS_WIDTH=20
72 TIME_WIDTH=12
73 STATUS_WIDTH=8
74 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
75 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
76
e9a57acd
MT
77 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
78 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 79}
69a6ec55 80
401a1edc
MT
81# Initially setup terminal
82resize_terminal
f9783277 83
401a1edc
MT
84# Call resize_terminal when terminal is being resized
85trap "resize_terminal" WINCH
69a6ec55
MT
86
87# Define color for messages
88BOLD="\\033[1;39m"
89DONE="\\033[1;32m"
90SKIP="\\033[1;34m"
91WARN="\\033[1;35m"
92FAIL="\\033[1;31m"
93NORMAL="\\033[0;39m"
94
bcb9dc13 95# New architecture variables
dc7d6b20 96HOST_ARCH="$(uname -m)"
94571564 97
69a6ec55
MT
98PWD=$(pwd)
99BASENAME=$(basename $0)
100
15679d9f
MT
101# Debian specific settings
102if [ ! -e /etc/debian_version ]; then
df5e82b3 103 FULLPATH=`which $0`
15679d9f 104else
df5e82b3
MT
105 if [ -x /usr/bin/realpath ]; then
106 FULLPATH=`/usr/bin/realpath $0`
107 else
108 echo "ERROR: Need to do apt-get install realpath"
109 exit 1
110 fi
15679d9f 111fi
df5e82b3 112
69a6ec55 113# This is the directory where make.sh is in
aecbe123 114export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 115
ebaecf2c
AF
116LOGFILE=$BASEDIR/log/_build.preparation.log
117export LOGFILE
15679d9f 118DIR_CHK=$BASEDIR/cache/check
ebaecf2c 119mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 120
69a6ec55
MT
121system_processors() {
122 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
123}
124
125system_memory() {
126 local key val unit
127
128 while read -r key val unit; do
129 case "${key}" in
130 MemTotal:*)
131 # Convert to MB
132 echo "$(( ${val} / 1024 ))"
133 break
134 ;;
135 esac
136 done < /proc/meminfo
137}
138
139configure_build() {
140 local build_arch="${1}"
141
142 if [ "${build_arch}" = "default" ]; then
143 build_arch="$(configure_build_guess)"
144 fi
145
146 case "${build_arch}" in
147 x86_64)
148 BUILDTARGET="${build_arch}-unknown-linux-gnu"
149 CROSSTARGET="${build_arch}-cross-linux-gnu"
150 BUILD_PLATFORM="x86"
5eec0f21 151 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
69a6ec55
MT
152 ;;
153
69a6ec55
MT
154 aarch64)
155 BUILDTARGET="${build_arch}-unknown-linux-gnu"
156 CROSSTARGET="${build_arch}-cross-linux-gnu"
157 BUILD_PLATFORM="arm"
87f3b1e5 158 CFLAGS_ARCH="-fstack-clash-protection"
69a6ec55
MT
159 ;;
160
161 armv7hl)
162 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
163 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
164 BUILD_PLATFORM="arm"
165 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
166 ;;
167
aafdd71b 168 armv6l)
69a6ec55
MT
169 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
170 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
171 BUILD_PLATFORM="arm"
f3fda4d3 172 CFLAGS_ARCH="-march=armv6zk+fp -mfpu=vfp -mfloat-abi=softfp -fomit-frame-pointer"
69a6ec55
MT
173 ;;
174
161eb15d
MT
175 riscv64)
176 BUILDTARGET="${build_arch}-unknown-linux-gnu"
177 CROSSTARGET="${build_arch}-cross-linux-gnu"
178 BUILD_PLATFORM="riscv"
0c304b7b 179 CFLAGS_ARCH="-fstack-clash-protection"
161eb15d
MT
180 ;;
181
69a6ec55
MT
182 *)
183 exiterror "Cannot build for architure ${build_arch}"
184 ;;
185 esac
186
187 # Check if the QEMU helper is available if needed.
188 if qemu_is_required "${build_arch}"; then
189 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
190
191 if [ -n "${qemu_build_helper}" ]; then
192 QEMU_TARGET_HELPER="${qemu_build_helper}"
193 else
194 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
195 fi
196 fi
197
198 BUILD_ARCH="${build_arch}"
199 TOOLS_DIR="/tools_${BUILD_ARCH}"
200
201 # Enables hardening
54114eb0 202 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
203
204 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
205 CXXFLAGS="${CFLAGS}"
206
c75e90c8
MT
207 RUSTFLAGS="-Copt-level=3 -Clink-arg=-Wl,-z,relro,-z,now -Ccodegen-units=1 --cap-lints=warn ${RUSTFLAGS_ARCH}"
208
69a6ec55 209 # Determine parallelism
eeee108f 210 # We assume that each process consumes about
297473d5 211 # 128MB of memory. Therefore we find out how
eeee108f 212 # many processes fit into memory.
297473d5 213 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
72c39057 214 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
eeee108f
MT
215
216 local parallelism
217 if [ ${mem_max} -lt ${cpu_max} ]; then
218 parallelism=${mem_max}
219 else
220 parallelism=${cpu_max}
69a6ec55 221 fi
212f17c1 222
eeee108f
MT
223 # Use this as default PARALLELISM
224 DEFAULT_PARALLELISM="${parallelism}"
225
e1616eb4
SS
226 # Limit lauched ninja build jobs to computed parallel value.
227 NINJAJOBS="${parallelism}"
228
212f17c1
MT
229 # Compression parameters
230 # We use mode 8 for reasonable memory usage when decompressing
231 # but with overall good compression
232 XZ_OPT="-8"
233
234 # We try to use as many cores as possible
235 XZ_OPT="${XZ_OPT} -T0"
236
237 # We need to limit memory because XZ uses too much when running
238 # in parallel and it isn't very smart in limiting itself.
239 # We allow XZ to use up to 70% of all system memory.
deffc275 240 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
241
242 # XZ memory cannot be larger than 2GB on 32 bit systems
243 case "${build_arch}" in
6cf219c4 244 armv*)
212f17c1
MT
245 if [ ${xz_memory} -gt 2048 ]; then
246 xz_memory=2048
247 fi
248 ;;
249 esac
250
251 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
252}
253
254configure_build_guess() {
255 case "${HOST_ARCH}" in
87487585
MT
256 x86_64)
257 echo "x86_64"
258 ;;
69a6ec55
MT
259
260 aarch64)
261 echo "aarch64"
262 ;;
263
aafdd71b
AF
264 armv7*|armv6*)
265 echo "armv6l"
69a6ec55
MT
266 ;;
267
161eb15d
MT
268 riscv64)
269 echo "riscv64"
270 ;;
271
69a6ec55
MT
272 *)
273 exiterror "Cannot guess build architecture"
274 ;;
275 esac
276}
277
f9783277
MT
278stdumount() {
279 umount $BASEDIR/build/sys 2>/dev/null;
280 umount $BASEDIR/build/dev/shm 2>/dev/null;
281 umount $BASEDIR/build/dev/pts 2>/dev/null;
282 umount $BASEDIR/build/dev 2>/dev/null;
283 umount $BASEDIR/build/proc 2>/dev/null;
284 umount $BASEDIR/build/install/mnt 2>/dev/null;
285 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
286 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
287 umount $BASEDIR/build/usr/src/config 2>/dev/null;
288 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
289 umount $BASEDIR/build/usr/src/html 2>/dev/null;
290 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
291 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 292 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 293 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 294 umount $BASEDIR/build/usr/src 2>/dev/null;
cb658c8c 295 umount $BASEDIR/build/tmp 2>/dev/null;
f9783277
MT
296}
297
298now() {
299 date -u "+%s"
69a6ec55
MT
300}
301
f9783277
MT
302format_runtime() {
303 local seconds=${1}
304
305 if [ ${seconds} -ge 3600 ]; then
306 printf "%d:%02d:%02d\n" \
307 "$(( seconds / 3600 ))" \
308 "$(( seconds % 3600 / 60 ))" \
309 "$(( seconds % 3600 % 60 ))"
310 elif [ ${seconds} -ge 60 ]; then
311 printf "%d:%02d\n" \
312 "$(( seconds / 60 ))" \
313 "$(( seconds % 60 ))"
69a6ec55 314 else
f9783277 315 printf "%d\n" "${seconds}"
69a6ec55 316 fi
f9783277 317}
69a6ec55 318
f9783277
MT
319print_line() {
320 local line="$@"
69a6ec55 321
f9783277 322 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
323}
324
f9783277
MT
325_print_line() {
326 local status="${1}"
327 shift
69a6ec55 328
f9783277
MT
329 if ${INTERACTIVE}; then
330 printf "${!status}"
331 fi
69a6ec55 332
f9783277
MT
333 print_line "$@"
334
335 if ${INTERACTIVE}; then
336 printf "${NORMAL}"
337 fi
338}
339
340print_headline() {
341 _print_line BOLD "$@"
69a6ec55
MT
342}
343
f9783277
MT
344print_error() {
345 _print_line FAIL "$@"
346}
347
348print_package() {
349 local name="${1}"
350 shift
69a6ec55 351
f9783277
MT
352 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
353 local options="$@"
354
355 local string="${name}"
356 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
357 string="${string} (${version})"
358 fi
359
360 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 361 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
362}
363
364print_runtime() {
365 local runtime=$(format_runtime $@)
366
367 if ${INTERACTIVE}; then
368 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
369 else
370 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 371 fi
f9783277
MT
372}
373
374print_status() {
375 local status="${1}"
376
377 local color="${!status}"
378
379 if ${INTERACTIVE}; then
380 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
381 else
382 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 383 fi
f9783277 384}
69a6ec55 385
f9783277
MT
386print_build_stage() {
387 print_headline "$@"
388
389 # end line
390 printf "\n"
69a6ec55
MT
391}
392
f9783277
MT
393print_build_summary() {
394 local runtime=$(format_runtime $@)
395
396 print_line "*** Build finished in ${runtime}"
397 print_status DONE
69a6ec55
MT
398}
399
400exiterror() {
401 stdumount
402 for i in `seq 0 7`; do
403 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
404 losetup -d /dev/loop${i} 2>/dev/null
405 fi;
406 done
407
f9783277 408 # Dump logfile
66028310 409 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
410 echo # empty line
411
412 local line
413 while read -r line; do
414 echo " ${line}"
415 done <<< "$(tail -n30 ${LOGFILE})"
416 fi
417
f9783277
MT
418 echo # empty line
419
420 local line
421 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
422 print_error "${line}"
423 print_status FAIL
424 done
425
69a6ec55
MT
426 exit 1
427}
428
aecbe123
MT
429prepareenv() {
430 # Are we running the right shell?
54328605 431 if [ -z "${BASH}" ]; then
aecbe123
MT
432 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
433 fi
434
435 if [ -z "${BASH_VERSION}" ]; then
436 exiterror "Not running BASH shell."
437 fi
438
439 # Trap on emergency exit
440 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
441
aecbe123 442 # Checking if running as root user
658232a6 443 if [ $(id -u) -ne 0 ]; then
df7f30a1 444 exiterror "root privileges required for building"
aecbe123
MT
445 fi
446
447 # Checking for necessary temporary space
f9783277 448 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
449 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
450 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
451 if (( 2048000 > $BASE_ASPACE )); then
452 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
453 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 454 print_status FAIL
aecbe123
MT
455 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
456 fi
457 else
f9783277 458 print_status DONE
aecbe123
MT
459 fi
460
461 # Set umask
462 umask 022
463
464 # Set LFS Directory
465 LFS=$BASEDIR/build
466
aecbe123
MT
467 # Setup environment
468 set +h
469 LC_ALL=POSIX
e1616eb4 470 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
aecbe123
MT
471 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
472
473 # Make some extra directories
474 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
475 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
476 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
380aa6e5 477 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
7c984de6
MT
478
479 if [ "${ENABLE_RAMDISK}" = "on" ]; then
480 mkdir -p $BASEDIR/build/usr/src
815ca15d 481 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
482
483 mkdir -p ${BASEDIR}/build/tmp
484 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
485 fi
486
ebaecf2c 487 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
488
489 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
490 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
491
492 # Make all sources and proc available under lfs build
493 mount --bind /dev $BASEDIR/build/dev
494 mount --bind /dev/pts $BASEDIR/build/dev/pts
495 mount --bind /dev/shm $BASEDIR/build/dev/shm
496 mount --bind /proc $BASEDIR/build/proc
497 mount --bind /sys $BASEDIR/build/sys
498 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
380aa6e5 499 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
aecbe123
MT
500 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
501 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
502 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
503 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
504 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 505 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
506 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
507
508 # Run LFS static binary creation scripts one by one
509 export CCACHE_DIR=$BASEDIR/ccache
36065e42 510 export CCACHE_TEMPDIR="/tmp"
aecbe123
MT
511 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
512
513 # Remove pre-install list of installed files in case user erase some files before rebuild
514 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
515
516 # Prepare string for /etc/system-release.
f48643e5
MT
517 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
518
519 case "${GIT_BRANCH}" in
520 core*|beta?|rc?)
521 system_release="${system_release} - ${GIT_BRANCH}"
522 ;;
523 *)
9ff65bfa 524 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 525 ;;
aecbe123 526 esac
4e54a8e2 527
f48643e5
MT
528 # Append -dirty tag for local changes
529 if [ "$(git status -s | wc -l)" != "0" ]; then
530 system_release="${system_release}-dirty"
531 fi
532
533 # Export variable
534 SYSTEM_RELEASE="${system_release}"
535
040160c7
MT
536 # Decide on PAKFIRE_TREE
537 case "${GIT_BRANCH}" in
538 core*)
539 PAKFIRE_TREE="stable"
540 ;;
541 master)
542 PAKFIRE_TREE="testing"
543 ;;
544 *)
545 PAKFIRE_TREE="unstable"
546 ;;
547 esac
548
4e54a8e2
MT
549 # Setup ccache cache size
550 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
551}
552
69a6ec55
MT
553enterchroot() {
554 # Install QEMU helper, if needed
555 qemu_install_helper
556
557 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
558
559 PATH="${PATH}" chroot ${LFS} env -i \
560 HOME="/root" \
561 TERM="${TERM}" \
562 PS1="${PS1}" \
563 PATH="${PATH}" \
564 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 565 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
566 NAME="${NAME}" \
567 SNAME="${SNAME}" \
568 VERSION="${VERSION}" \
569 CORE="${CORE}" \
570 SLOGAN="${SLOGAN}" \
571 TOOLS_DIR="${TOOLS_DIR}" \
572 CONFIG_ROOT="${CONFIG_ROOT}" \
573 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
574 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 575 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
576 BUILDTARGET="${BUILDTARGET}" \
577 CROSSTARGET="${CROSSTARGET}" \
578 BUILD_ARCH="${BUILD_ARCH}" \
579 BUILD_PLATFORM="${BUILD_PLATFORM}" \
580 CCACHE_DIR=/usr/src/ccache \
36065e42 581 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55 582 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 583 GOCACHE="/usr/src/ccache/go" \
69a6ec55 584 KVER="${KVER}" \
0d7a6f03 585 XZ_OPT="${XZ_OPT}" \
77c863a2 586 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
587 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
588 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
589 $(fake_environ) \
590 $(qemu_environ) \
591 "$@"
592}
593
594entershell() {
595 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
596 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
597 fi
598
599 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 600 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
601
602 if enterchroot bash -i; then
603 stdumount
604 else
f9783277 605 print_status FAIL
69a6ec55
MT
606 exiterror "chroot error"
607 fi
608}
609
610lfsmakecommoncheck() {
611 # Script present?
612 if [ ! -f $BASEDIR/lfs/$1 ]; then
613 exiterror "No such file or directory: $BASEDIR/$1"
614 fi
615
f9783277
MT
616 # Print package name and version
617 print_package $@
69a6ec55
MT
618
619 # Check if this package is supported by our architecture.
620 # If no SUP_ARCH is found, we assume the package can be built for all.
621 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
622 # Check if package supports ${BUILD_ARCH} or all architectures.
623 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 624 print_runtime 0
f9783277 625 print_status SKIP
69a6ec55
MT
626 return 1
627 fi
628 fi
629
630 # Script slipped?
631 local i
632 for i in $SKIP_PACKAGE_LIST
633 do
634 if [ "$i" == "$1" ]; then
f9783277 635 print_status SKIP
69a6ec55
MT
636 return 1;
637 fi
638 done
639
640 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
641
642 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
643 MESSAGE="$1\t " download >> $LOGFILE 2>&1
644 if [ $? -ne 0 ]; then
645 exiterror "Download error in $1"
646 fi
647
648 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
649 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
650 if [ $? -ne 0 ]; then
651 exiterror "md5sum error in $1, check file in cache or signature"
652 fi
653
654 return 0 # pass all!
655}
656
657lfsmake1() {
658 lfsmakecommoncheck $*
659 [ $? == 1 ] && return 0
660
69a6ec55
MT
661 cd $BASEDIR/lfs && env -i \
662 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
4301024b 663 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
36065e42 664 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
665 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
666 CFLAGS="${CFLAGS}" \
667 CXXFLAGS="${CXXFLAGS}" \
77c863a2 668 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
669 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
670 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
671 make -f $* \
672 TOOLCHAIN=1 \
673 TOOLS_DIR="${TOOLS_DIR}" \
674 CROSSTARGET="${CROSSTARGET}" \
675 BUILDTARGET="${BUILDTARGET}" \
676 BUILD_ARCH="${BUILD_ARCH}" \
677 BUILD_PLATFORM="${BUILD_PLATFORM}" \
678 LFS_BASEDIR="${BASEDIR}" \
679 ROOT="${LFS}" \
680 KVER="${KVER}" \
f9783277 681 install >> $LOGFILE 2>&1 &
69a6ec55 682
f9783277
MT
683 if ! wait_until_finished $!; then
684 print_status FAIL
685 exiterror "Building $*"
69a6ec55
MT
686 fi
687
f9783277 688 print_status DONE
69a6ec55
MT
689}
690
691lfsmake2() {
692 lfsmakecommoncheck $*
693 [ $? == 1 ] && return 0
694
69a6ec55
MT
695 local PS1='\u:\w$ '
696
697 enterchroot \
ce9264a1 698 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
699 make -f $* \
700 LFS_BASEDIR=/usr/src install" \
f9783277 701 >> ${LOGFILE} 2>&1 &
69a6ec55 702
f9783277
MT
703 if ! wait_until_finished $!; then
704 print_status FAIL
705 exiterror "Building $*"
69a6ec55
MT
706 fi
707
f9783277 708 print_status DONE
69a6ec55
MT
709}
710
711ipfiredist() {
712 lfsmakecommoncheck $*
713 [ $? == 1 ] && return 0
714
69a6ec55
MT
715 local PS1='\u:\w$ '
716
717 enterchroot \
718 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 719 >> ${LOGFILE} 2>&1 &
69a6ec55 720
f9783277
MT
721 if ! wait_until_finished $!; then
722 print_status FAIL
723 exiterror "Packaging $*"
724 fi
69a6ec55 725
f9783277
MT
726 print_status DONE
727}
728
729wait_until_finished() {
730 local pid=${1}
731
732 local start_time=$(now)
733
734 # Show progress
735 if ${INTERACTIVE}; then
736 # Wait a little just in case the process
737 # has finished very quickly.
738 sleep 0.1
739
740 local runtime
741 while kill -0 ${pid} 2>/dev/null; do
742 print_runtime $(( $(now) - ${start_time} ))
743
744 # Wait a little
745 sleep 1
746 done
69a6ec55 747 fi
f9783277
MT
748
749 # Returns the exit code of the child process
750 wait ${pid}
751 local ret=$?
752
753 if ! ${INTERACTIVE}; then
754 print_runtime $(( $(now) - ${start_time} ))
755 fi
756
757 return ${ret}
69a6ec55
MT
758}
759
760fake_environ() {
761 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
762
763 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
764
765 # Fake kernel version, because some of the packages do not compile
766 # with kernel 3.0 and later.
8634797e 767 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
768
769 # Fake machine version.
770 env="${env} UTS_MACHINE=${BUILD_ARCH}"
771
772 echo "${env}"
773}
774
775qemu_environ() {
776 local env
777
778 # Don't add anything if qemu is not used.
779 if ! qemu_is_required; then
780 return
781 fi
782
783 # Set default qemu options
784 case "${BUILD_ARCH}" in
785 arm*)
786 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
787
788 env="${env} QEMU_CPU=${QEMU_CPU}"
789 ;;
790 esac
791
792 # Enable QEMU strace
793 #env="${env} QEMU_STRACE=1"
794
795 echo "${env}"
796}
797
798qemu_is_required() {
799 local build_arch="${1}"
800
801 if [ -z "${build_arch}" ]; then
802 build_arch="${BUILD_ARCH}"
803 fi
804
805 case "${HOST_ARCH},${build_arch}" in
161eb15d 806 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
69a6ec55
MT
807 return 0
808 ;;
809 *)
810 return 1
811 ;;
812 esac
813}
814
815qemu_install_helper() {
816 # Do nothing, if qemu is not required
817 if ! qemu_is_required; then
818 return 0
819 fi
820
821 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
822 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
823 fi
824
825 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
826 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
827 fi
828
829
830 if [ -z "${QEMU_TARGET_HELPER}" ]; then
831 exiterror "QEMU_TARGET_HELPER not set"
832 fi
833
834 # Check if the helper is already installed.
835 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
836 return 0
837 fi
838
839 # Try to find a suitable binary that we can install
840 # to the build environment.
841 local file
842 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
843 # file must exist and be executable.
844 [ -x "${file}" ] || continue
845
846 # Must be static.
847 file_is_static "${file}" || continue
848
849 local dirname="${LFS}$(dirname "${file}")"
850 mkdir -p "${dirname}"
851
852 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
853 return 0
854 done
855
856 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
857}
858
859qemu_find_build_helper_name() {
860 local build_arch="${1}"
861
862 local magic
863 case "${build_arch}" in
0db0f7fa
AF
864 aarch64)
865 magic="7f454c460201010000000000000000000200b700"
866 ;;
4576ca4c
MT
867 arm*)
868 magic="7f454c4601010100000000000000000002002800"
869 ;;
161eb15d
MT
870 riscv64)
871 magic="7f454c460201010000000000000000000200f300"
872 ;;
69a6ec55
MT
873 x86_64)
874 magic="7f454c4602010100000000000000000002003e00"
875 ;;
876 esac
877
878 [ -z "${magic}" ] && return 1
879
880 local file
881 for file in /proc/sys/fs/binfmt_misc/*; do
882 # skip write only register entry
883 [ $(basename "${file}") = "register" ] && continue
884 # Search for the file with the correct magic value.
885 grep -qE "^magic ${magic}$" "${file}" || continue
886
887 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
888
889 [ -n "${interpreter}" ] || continue
890 [ "${interpreter:0:1}" = "/" ] || continue
891 [ -x "${interpreter}" ] || continue
892
893 echo "${interpreter}"
894 return 0
895 done
896
897 return 1
898}
899
900file_is_static() {
901 local file="${1}"
902
903 file ${file} 2>/dev/null | grep -q "statically linked"
904}
905
906update_language_list() {
907 local path="${1}"
908
909 local lang
910 for lang in ${path}/*.po; do
911 lang="$(basename "${lang}")"
912 echo "${lang%*.po}"
913 done | sort -u > "${path}/LINGUAS"
914}
915
1fb7f56e
MT
916contributors() {
917 local commits name
918
919 git shortlog --summary --numbered | while read -r commits name; do
920 echo "${name}"
921 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
922}
923
924update_contributors() {
925 echo -n "Updating list of contributors"
926
927 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
928
929 # Edit contributors into credits.cgi
e2338aa7
MT
930 local tmp="$(mktemp)"
931
932 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
933 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
934
935 # Copy back modified content
936 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
937 unlink "${tmp}"
1fb7f56e
MT
938
939 print_status DONE
940 return 0
941}
942
15b005d8 943# Default settings
99597de7 944CCACHE_CACHE_SIZE="4G"
15b005d8
MT
945ENABLE_RAMDISK="auto"
946
a98ab1d7
MT
947# Load configuration file
948if [ -f .config ]; then
949 . .config
950fi
951
813659f2
MT
952# TARGET_ARCH is BUILD_ARCH now
953if [ -n "${TARGET_ARCH}" ]; then
954 BUILD_ARCH="${TARGET_ARCH}"
955 unset TARGET_ARCH
956fi
957
85560933
MT
958# Get some information about the host system
959SYSTEM_PROCESSORS="$(system_processors)"
960SYSTEM_MEMORY="$(system_memory)"
961
dc7d6b20
MT
962if [ -n "${BUILD_ARCH}" ]; then
963 configure_build "${BUILD_ARCH}"
949544f5 964else
dc7d6b20 965 configure_build "default"
949544f5
MT
966fi
967
15b005d8
MT
968# Automatically enable/disable ramdisk usage
969if [ "${ENABLE_RAMDISK}" = "auto" ]; then
970 # Enable only when the host system has 4GB of RAM or more
971 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
972 ENABLE_RAMDISK="on"
973 fi
974fi
975
df5e82b3 976buildtoolchain() {
69a6ec55
MT
977 local error=false
978 case "${BUILD_ARCH}:${HOST_ARCH}" in
979 # x86_64
980 x86_64:x86_64)
981 # This is working.
982 ;;
983
69a6ec55
MT
984 # ARM
985 arvm7hl:armv7hl|armv7hl:armv7l)
986 # These are working.
987 ;;
988
aafdd71b 989 armv6l:armv6l|armv6l:armv7l|armv6l:aarch64)
69a6ec55
MT
990 # These are working.
991 ;;
aafdd71b 992 armv6l:*)
69a6ec55
MT
993 error=true
994 ;;
995 esac
996
997 ${error} && \
998 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
999
1000 local gcc=$(type -p gcc)
1001 if [ -z "${gcc}" ]; then
1002 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1003 fi
1004
6bd3a131
MT
1005 # Check ${TOOLS_DIR} symlink
1006 if [ -h "${TOOLS_DIR}" ]; then
1007 rm -f "${TOOLS_DIR}"
1008 fi
1009
1010 if [ ! -e "${TOOLS_DIR}" ]; then
1011 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1012 fi
1013
1014 if [ ! -h "${TOOLS_DIR}" ]; then
1015 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1016 fi
1017
ebaecf2c 1018 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
1019 export LOGFILE
1020
1021 lfsmake1 stage1
69a6ec55
MT
1022 lfsmake1 binutils PASS=1
1023 lfsmake1 gcc PASS=1
1024 lfsmake1 linux KCFG="-headers"
1025 lfsmake1 glibc
178c7a6a 1026 lfsmake1 libxcrypt
69a6ec55 1027 lfsmake1 gcc PASS=L
54d54148 1028 lfsmake1 zlib
2d29899d 1029 lfsmake1 zstd
7d14c775
MT
1030 lfsmake1 binutils PASS=2
1031 lfsmake1 gcc PASS=2
74ee1c7a 1032 lfsmake1 ccache
69a6ec55
MT
1033 lfsmake1 tcl
1034 lfsmake1 expect
1035 lfsmake1 dejagnu
1036 lfsmake1 pkg-config
1037 lfsmake1 ncurses
1038 lfsmake1 bash
1039 lfsmake1 bzip2
1040 lfsmake1 automake
1041 lfsmake1 coreutils
1042 lfsmake1 diffutils
1043 lfsmake1 findutils
1044 lfsmake1 gawk
1045 lfsmake1 gettext
1046 lfsmake1 grep
1047 lfsmake1 gzip
1048 lfsmake1 m4
1049 lfsmake1 make
1050 lfsmake1 patch
1051 lfsmake1 perl
46bbc13b 1052 lfsmake1 python3
69a6ec55
MT
1053 lfsmake1 sed
1054 lfsmake1 tar
1055 lfsmake1 texinfo
1056 lfsmake1 xz
85439ac7 1057 lfsmake1 bison
11b5e5cb 1058 lfsmake1 flex
69a6ec55 1059 lfsmake1 fake-environ
7b93b62b 1060 lfsmake1 strip
69a6ec55 1061 lfsmake1 cleanup-toolchain
df5e82b3
MT
1062}
1063
1064buildbase() {
ebaecf2c 1065 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1066 export LOGFILE
1067 lfsmake2 stage2
1068 lfsmake2 linux KCFG="-headers"
1069 lfsmake2 man-pages
1070 lfsmake2 glibc
1071 lfsmake2 tzdata
1072 lfsmake2 cleanup-toolchain
1073 lfsmake2 zlib
b14c24ca 1074 lfsmake2 zstd
cf6c8e67
MT
1075 lfsmake2 autoconf
1076 lfsmake2 automake
1077 lfsmake2 libtool
69a6ec55
MT
1078 lfsmake2 binutils
1079 lfsmake2 gmp
69a6ec55
MT
1080 lfsmake2 mpfr
1081 lfsmake2 libmpc
cf6c8e67 1082 lfsmake2 libxcrypt
69a6ec55
MT
1083 lfsmake2 file
1084 lfsmake2 gcc
1085 lfsmake2 sed
69a6ec55
MT
1086 lfsmake2 berkeley
1087 lfsmake2 coreutils
1088 lfsmake2 iana-etc
1089 lfsmake2 m4
1090 lfsmake2 bison
69a6ec55 1091 lfsmake2 ncurses
69a6ec55
MT
1092 lfsmake2 perl
1093 lfsmake2 readline
69a6ec55 1094 lfsmake2 bzip2
3ece7859 1095 lfsmake2 xz
f407f05a 1096 lfsmake2 lzip
69a6ec55 1097 lfsmake2 pcre
b0c37190 1098 lfsmake2 pcre2
d701756a 1099 lfsmake2 gettext
241bf919
MT
1100 lfsmake2 attr
1101 lfsmake2 acl
69a6ec55
MT
1102 lfsmake2 bash
1103 lfsmake2 diffutils
69a6ec55
MT
1104 lfsmake2 ed
1105 lfsmake2 findutils
1106 lfsmake2 flex
1107 lfsmake2 gawk
d2315d00 1108 lfsmake2 go
69a6ec55
MT
1109 lfsmake2 grep
1110 lfsmake2 groff
1111 lfsmake2 gperf
1112 lfsmake2 gzip
1113 lfsmake2 hostname
ac36f9f2 1114 lfsmake2 whois
69a6ec55
MT
1115 lfsmake2 kbd
1116 lfsmake2 less
4720fa0d 1117 lfsmake2 pkg-config
50992c73 1118 lfsmake2 procps
69a6ec55
MT
1119 lfsmake2 make
1120 lfsmake2 man
69a6ec55
MT
1121 lfsmake2 net-tools
1122 lfsmake2 patch
1123 lfsmake2 psmisc
1124 lfsmake2 shadow
1125 lfsmake2 sysklogd
1126 lfsmake2 sysvinit
1127 lfsmake2 tar
1128 lfsmake2 texinfo
1129 lfsmake2 util-linux
69a6ec55 1130 lfsmake2 vim
69b3d63b 1131 lfsmake2 e2fsprogs
c9fb8808 1132 lfsmake2 jq
df5e82b3
MT
1133}
1134
15679d9f 1135buildipfire() {
ebaecf2c 1136 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1137 export LOGFILE
489145db
MT
1138 lfsmake2 configroot
1139 lfsmake2 initscripts
1140 lfsmake2 backup
c38f55fe 1141 lfsmake2 openssl
1ece41ec 1142 lfsmake2 kmod
e1c6cd05 1143 lfsmake2 udev
3755e358 1144 lfsmake2 popt
d4767896 1145 lfsmake2 libedit
489145db
MT
1146 lfsmake2 libusb
1147 lfsmake2 libusb-compat
1148 lfsmake2 libpcap
1149 lfsmake2 ppp
1150 lfsmake2 pptp
1151 lfsmake2 unzip
1152 lfsmake2 which
1153 lfsmake2 linux-firmware
489145db 1154 lfsmake2 dvb-firmwares
37b86fa9 1155 lfsmake2 xr819-firmware
489145db
MT
1156 lfsmake2 zd1211-firmware
1157 lfsmake2 rpi-firmware
26796f3a 1158 lfsmake2 intel-microcode
0e54ca26 1159 lfsmake2 pcengines-apu-firmware
489145db 1160 lfsmake2 bc
2a0947f2 1161 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1162 lfsmake2 cpio
1163 lfsmake2 mdadm
1164 lfsmake2 dracut
de18b4de 1165 lfsmake2 libaio
489145db
MT
1166 lfsmake2 lvm2
1167 lfsmake2 multipath-tools
1168 lfsmake2 freetype
489145db
MT
1169 lfsmake2 libmnl
1170 lfsmake2 libnfnetlink
1171 lfsmake2 libnetfilter_queue
1172 lfsmake2 libnetfilter_conntrack
1173 lfsmake2 libnetfilter_cthelper
1174 lfsmake2 libnetfilter_cttimeout
1175 lfsmake2 iptables
66bc17dc 1176 lfsmake2 iproute2
0245f3b6 1177 lfsmake2 screen
54ead8ef 1178 lfsmake2 elfutils
8e6fb99d 1179
efafef16
AF
1180 # Kernelbuild ... current we have no platform that need
1181 # multi kernel builds so KCFG is empty
1182 lfsmake2 linux KCFG=""
1183 lfsmake2 rtl8189es KCFG=""
1184 lfsmake2 rtl8812au KCFG=""
8bb80576 1185 lfsmake2 rtl8822bu KCFG=""
efafef16
AF
1186 lfsmake2 xradio KCFG=""
1187 lfsmake2 xtables-addons KCFG=""
1188 lfsmake2 linux-initrd KCFG=""
1189
1190 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1191 lfsmake2 libgpg-error
1192 lfsmake2 libgcrypt
1193 lfsmake2 libassuan
1194 lfsmake2 nettle
1a7db134 1195 lfsmake2 json-c
f3e62301 1196 lfsmake2 libconfig
489145db
MT
1197 lfsmake2 libevent
1198 lfsmake2 libevent2
1199 lfsmake2 expat
c8e9a7a8
WA
1200 lfsmake2 apr
1201 lfsmake2 aprutil
489145db
MT
1202 lfsmake2 unbound
1203 lfsmake2 gnutls
689246f5 1204 lfsmake2 libuv
489145db
MT
1205 lfsmake2 bind
1206 lfsmake2 dhcp
1207 lfsmake2 dhcpcd
1208 lfsmake2 boost
1209 lfsmake2 linux-atm
1210 lfsmake2 gdbm
1211 lfsmake2 pam
d44ce7d4 1212 lfsmake2 c-ares
489145db
MT
1213 lfsmake2 curl
1214 lfsmake2 tcl
1215 lfsmake2 sqlite
1216 lfsmake2 libffi
489145db 1217 lfsmake2 python3
150de02e 1218 lfsmake2 rust
321e91cd 1219 lfsmake2 rust-dissimilar
df47bf8b 1220 lfsmake2 rust-cfg-if
8a4495a4 1221 lfsmake2 gdb
b3ce3510
MT
1222 lfsmake2 grub
1223 lfsmake2 efivar
1224 lfsmake2 efibootmgr
40cdf896
AB
1225 lfsmake2 libtasn1
1226 lfsmake2 p11-kit
489145db
MT
1227 lfsmake2 ca-certificates
1228 lfsmake2 fireinfo
1229 lfsmake2 libnet
1230 lfsmake2 libnl
1231 lfsmake2 libnl-3
1232 lfsmake2 libidn
1233 lfsmake2 nasm
4f516b87
MF
1234 lfsmake2 libarchive
1235 lfsmake2 cmake
814a33ff
SS
1236 lfsmake2 ninja
1237 lfsmake2 meson
489145db 1238 lfsmake2 libjpeg
58d965fe 1239 lfsmake2 openjpeg
489145db
MT
1240 lfsmake2 libexif
1241 lfsmake2 libpng
1242 lfsmake2 libtiff
1243 lfsmake2 libart
1244 lfsmake2 gd
489145db
MT
1245 lfsmake2 slang
1246 lfsmake2 newt
1247 lfsmake2 libsmooth
489145db 1248 lfsmake2 libcap
b051eb68 1249 lfsmake2 libcap-ng
489145db
MT
1250 lfsmake2 pciutils
1251 lfsmake2 usbutils
1252 lfsmake2 libxml2
1253 lfsmake2 libxslt
1254 lfsmake2 BerkeleyDB
489145db
MT
1255 lfsmake2 cyrus-sasl
1256 lfsmake2 openldap
1257 lfsmake2 apache2
489145db
MT
1258 lfsmake2 web-user-interface
1259 lfsmake2 flag-icons
1260 lfsmake2 jquery
6033b271 1261 lfsmake2 bootstrap
489145db
MT
1262 lfsmake2 arping
1263 lfsmake2 beep
1df47cc9 1264 lfsmake2 libssh
ff075def 1265 lfsmake2 libinih
8a960584 1266 lfsmake2 cdrkit
489145db 1267 lfsmake2 dosfstools
574690dc 1268 lfsmake2 exfatprogs
489145db 1269 lfsmake2 reiserfsprogs
14192b69 1270 lfsmake2 liburcu
489145db
MT
1271 lfsmake2 xfsprogs
1272 lfsmake2 sysfsutils
1273 lfsmake2 fuse
1274 lfsmake2 ntfs-3g
1275 lfsmake2 ethtool
489145db 1276 lfsmake2 fcron
6cdc5164 1277 lfsmake2 ExtUtils-PkgConfig
489145db
MT
1278 lfsmake2 perl-GD
1279 lfsmake2 GD-Graph
1280 lfsmake2 GD-TextUtil
1281 lfsmake2 perl-Device-SerialPort
1282 lfsmake2 perl-Device-Modem
1283 lfsmake2 perl-Apache-Htpasswd
bbcaca56 1284 lfsmake2 perl-Parse-Yapp
46426b69 1285 lfsmake2 perl-Data-UUID
489145db
MT
1286 lfsmake2 gnupg
1287 lfsmake2 hdparm
1288 lfsmake2 sdparm
489145db 1289 lfsmake2 whatmask
29370584 1290 lfsmake2 libtirpc
489145db 1291 lfsmake2 conntrack-tools
489145db
MT
1292 lfsmake2 iputils
1293 lfsmake2 l7-protocols
489145db
MT
1294 lfsmake2 hwdata
1295 lfsmake2 logrotate
1296 lfsmake2 logwatch
1297 lfsmake2 misc-progs
1298 lfsmake2 nano
1299 lfsmake2 URI
294aa009
AF
1300 lfsmake2 perl-CGI
1301 lfsmake2 perl-Switch
489145db
MT
1302 lfsmake2 HTML-Tagset
1303 lfsmake2 HTML-Parser
1304 lfsmake2 HTML-Template
1305 lfsmake2 Compress-Zlib
1306 lfsmake2 Digest
1307 lfsmake2 Digest-SHA1
1308 lfsmake2 Digest-HMAC
15de7a78 1309 lfsmake2 libwww-perl
489145db
MT
1310 lfsmake2 Net-DNS
1311 lfsmake2 Net-IPv4Addr
1312 lfsmake2 Net_SSLeay
1313 lfsmake2 IO-Stringy
1314 lfsmake2 IO-Socket-SSL
1315 lfsmake2 Unix-Syslog
1316 lfsmake2 Mail-Tools
1317 lfsmake2 MIME-Tools
1318 lfsmake2 Net-Server
a7492c0f 1319 lfsmake2 Canary-Stability
489145db
MT
1320 lfsmake2 Convert-TNEF
1321 lfsmake2 Convert-UUlib
1322 lfsmake2 Archive-Tar
1323 lfsmake2 Archive-Zip
1324 lfsmake2 Text-Tabs+Wrap
489145db
MT
1325 lfsmake2 XML-Parser
1326 lfsmake2 Crypt-PasswdMD5
1327 lfsmake2 Net-Telnet
398669f7 1328 lfsmake2 python3-setuptools
d55a968a 1329 lfsmake2 python3-inotify
05fed717 1330 lfsmake2 python3-docutils
0882b3e4 1331 lfsmake2 python3-daemon
489145db 1332 lfsmake2 glib
489145db
MT
1333 lfsmake2 ntp
1334 lfsmake2 openssh
1335 lfsmake2 fontconfig
1336 lfsmake2 dejavu-fonts-ttf
70f6cba4 1337 lfsmake2 ubuntu-font-family
489145db
MT
1338 lfsmake2 freefont
1339 lfsmake2 pixman
1340 lfsmake2 cairo
0de1daf3
AB
1341 lfsmake2 harfbuzz
1342 lfsmake2 fribidi
489145db
MT
1343 lfsmake2 pango
1344 lfsmake2 rrdtool
489145db
MT
1345 lfsmake2 setup
1346 lfsmake2 libdnet
616395f3 1347 lfsmake2 jansson
91cc908f 1348 lfsmake2 yaml
3498300d 1349 lfsmake2 libhtp
1a5f0649 1350 lfsmake2 colm
2348cfff 1351 lfsmake2 ragel
52ebc66b 1352 lfsmake2 hyperscan
67752a95 1353 lfsmake2 suricata
489145db 1354 lfsmake2 oinkmaster
ef640882 1355 lfsmake2 ids-ruleset-sources
489145db
MT
1356 lfsmake2 squid
1357 lfsmake2 squidguard
1358 lfsmake2 calamaris
1359 lfsmake2 tcpdump
1360 lfsmake2 traceroute
1361 lfsmake2 vlan
1362 lfsmake2 wireless
1363 lfsmake2 pakfire
1364 lfsmake2 spandsp
adf3f4f4 1365 lfsmake2 lz4
489145db
MT
1366 lfsmake2 lzo
1367 lfsmake2 openvpn
489145db
MT
1368 lfsmake2 mpage
1369 lfsmake2 dbus
1370 lfsmake2 intltool
1371 lfsmake2 libdaemon
6064cd87 1372 lfsmake2 avahi
489145db 1373 lfsmake2 cups
489145db 1374 lfsmake2 lcms2
56170c2a 1375 lfsmake2 ghostscript
489145db
MT
1376 lfsmake2 qpdf
1377 lfsmake2 poppler
d3dabd4b 1378 lfsmake2 poppler-data
489145db
MT
1379 lfsmake2 cups-filters
1380 lfsmake2 epson-inkjet-printer-escpr
1381 lfsmake2 foomatic
1382 lfsmake2 hplip
1383 lfsmake2 cifs-utils
1384 lfsmake2 krb5
95849177 1385 lfsmake2 rpcsvc-proto
489145db 1386 lfsmake2 samba
18d000c4 1387 lfsmake2 netatalk
489145db
MT
1388 lfsmake2 sudo
1389 lfsmake2 mc
1390 lfsmake2 wget
1391 lfsmake2 bridge-utils
489145db
MT
1392 lfsmake2 smartmontools
1393 lfsmake2 htop
1394 lfsmake2 chkconfig
1395 lfsmake2 postfix
1396 lfsmake2 fetchmail
489145db 1397 lfsmake2 clamav
294aa009 1398 lfsmake2 perl-NetAddr-IP
489145db
MT
1399 lfsmake2 dma
1400 lfsmake2 alsa
1401 lfsmake2 mpfire
1402 lfsmake2 guardian
1403 lfsmake2 libid3tag
1404 lfsmake2 libmad
1405 lfsmake2 libogg
1406 lfsmake2 libvorbis
489145db
MT
1407 lfsmake2 flac
1408 lfsmake2 lame
1409 lfsmake2 sox
41f8d642 1410 lfsmake2 soxr
489145db
MT
1411 lfsmake2 libshout
1412 lfsmake2 xvid
1413 lfsmake2 libmpeg2
489145db
MT
1414 lfsmake2 gnump3d
1415 lfsmake2 rsync
489145db 1416 lfsmake2 rpcbind
14fb55a5 1417 lfsmake2 keyutils
8af744bc 1418 lfsmake2 libnfsidmap
489145db
MT
1419 lfsmake2 nfs
1420 lfsmake2 gnu-netcat
1421 lfsmake2 ncat
1422 lfsmake2 nmap
489145db
MT
1423 lfsmake2 etherwake
1424 lfsmake2 bwm-ng
1425 lfsmake2 sysstat
489145db
MT
1426 lfsmake2 strongswan
1427 lfsmake2 rng-tools
1428 lfsmake2 lsof
1429 lfsmake2 br2684ctl
1430 lfsmake2 pcmciautils
1431 lfsmake2 lm_sensors
25f26fb6 1432 lfsmake2 libstatgrab
489145db
MT
1433 lfsmake2 liboping
1434 lfsmake2 collectd
1435 lfsmake2 elinks
1436 lfsmake2 igmpproxy
489145db 1437 lfsmake2 opus
495cf3e0 1438 lfsmake2 python3-pyparsing
489145db
MT
1439 lfsmake2 spice-protocol
1440 lfsmake2 spice
15c01e30 1441 lfsmake2 sdl2
489145db 1442 lfsmake2 libusbredir
43c3a386 1443 lfsmake2 libseccomp
489145db 1444 lfsmake2 qemu
489145db 1445 lfsmake2 netpbm
489145db 1446 lfsmake2 netsnmpd
489145db 1447 lfsmake2 nagios_nrpe
2af354c2 1448 lfsmake2 nagios-plugins
489145db 1449 lfsmake2 icinga
01c2ea6b 1450 lfsmake2 observium-agent
489145db 1451 lfsmake2 ebtables
489145db 1452 lfsmake2 faad2
e91ceed6 1453 lfsmake2 alac
489145db
MT
1454 lfsmake2 ffmpeg
1455 lfsmake2 vdr
1456 lfsmake2 vdr_streamdev
489145db
MT
1457 lfsmake2 vdr_epgsearch
1458 lfsmake2 vdr_dvbapi
1459 lfsmake2 vdr_eepg
1460 lfsmake2 w_scan
489145db
MT
1461 lfsmake2 mpd
1462 lfsmake2 libmpdclient
1463 lfsmake2 mpc
985741db 1464 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1465 lfsmake2 perl-Net-SMTP-SSL
1466 lfsmake2 perl-MIME-Base64
1467 lfsmake2 perl-Authen-SASL
1468 lfsmake2 perl-MIME-Lite
1469 lfsmake2 perl-Email-Date-Format
1470 lfsmake2 git
1471 lfsmake2 squidclamav
1472 lfsmake2 vnstat
1473 lfsmake2 iw
1474 lfsmake2 wpa_supplicant
1475 lfsmake2 hostapd
489145db
MT
1476 lfsmake2 syslinux
1477 lfsmake2 tftpd
1478 lfsmake2 cpufrequtils
489145db
MT
1479 lfsmake2 gutenprint
1480 lfsmake2 apcupsd
67fbd255 1481 lfsmake2 fireperf
489145db
MT
1482 lfsmake2 iperf
1483 lfsmake2 iperf3
1484 lfsmake2 7zip
1485 lfsmake2 lynis
489145db
MT
1486 lfsmake2 sshfs
1487 lfsmake2 taglib
489145db
MT
1488 lfsmake2 sslh
1489 lfsmake2 perl-gettext
1490 lfsmake2 perl-Sort-Naturally
1491 lfsmake2 vdradmin
489145db 1492 lfsmake2 perl-DBI
489145db
MT
1493 lfsmake2 perl-DBD-SQLite
1494 lfsmake2 perl-File-ReadBackwards
489145db 1495 lfsmake2 openvmtools
489145db
MT
1496 lfsmake2 joe
1497 lfsmake2 monit
1498 lfsmake2 nut
1499 lfsmake2 watchdog
1500 lfsmake2 libpri
489145db
MT
1501 lfsmake2 usb_modeswitch
1502 lfsmake2 usb_modeswitch_data
1503 lfsmake2 zerofree
489145db
MT
1504 lfsmake2 minicom
1505 lfsmake2 ddrescue
489145db
MT
1506 lfsmake2 powertop
1507 lfsmake2 parted
1508 lfsmake2 swig
4c59cad1 1509 lfsmake2 dtc
2a0947f2 1510 lfsmake2 u-boot
6836e528 1511 lfsmake2 u-boot-friendlyarm
489145db 1512 lfsmake2 wireless-regdb
489145db 1513 lfsmake2 libsolv
489145db 1514 lfsmake2 ddns
662b2a81 1515 lfsmake2 python3-setuptools-scm
5996c281 1516 lfsmake2 python3-six
e0a05a80 1517 lfsmake2 python3-dateutil
d48ea6b5 1518 lfsmake2 python3-jmespath
a33ca4cc 1519 lfsmake2 python3-colorama
d2da17a1 1520 lfsmake2 python3-yaml
953f6f73 1521 lfsmake2 python3-s3transfer
d45d5247 1522 lfsmake2 python3-rsa
faa5472a 1523 lfsmake2 python3-pyasn1
05be1c64 1524 lfsmake2 python3-urllib3
4ab80c5d 1525 lfsmake2 python3-botocore
def9f4a3 1526 lfsmake2 python3-msgpack
280ee7e7 1527 lfsmake2 aws-cli
489145db 1528 lfsmake2 transmission
489145db 1529 lfsmake2 mtr
489145db
MT
1530 lfsmake2 minidlna
1531 lfsmake2 acpid
1532 lfsmake2 fping
1533 lfsmake2 telnet
1534 lfsmake2 xinetd
489145db 1535 lfsmake2 stress
489145db 1536 lfsmake2 sarg
489145db 1537 lfsmake2 nginx
489145db
MT
1538 lfsmake2 sysbench
1539 lfsmake2 strace
489145db
MT
1540 lfsmake2 ltrace
1541 lfsmake2 ipfire-netboot
1542 lfsmake2 lcdproc
489145db
MT
1543 lfsmake2 keepalived
1544 lfsmake2 ipvsadm
1545 lfsmake2 perl-Carp-Clan
1546 lfsmake2 perl-Date-Calc
1547 lfsmake2 perl-Date-Manip
1548 lfsmake2 perl-File-Tail
1549 lfsmake2 perl-TimeDate
1550 lfsmake2 swatch
1551 lfsmake2 tor
489145db
MT
1552 lfsmake2 wavemon
1553 lfsmake2 iptraf-ng
1554 lfsmake2 iotop
1555 lfsmake2 stunnel
489145db 1556 lfsmake2 bacula
b62c826f
MT
1557 lfsmake2 perl-Font-TTF
1558 lfsmake2 perl-IO-String
489145db
MT
1559 lfsmake2 perl-PDF-API2
1560 lfsmake2 squid-accounting
1561 lfsmake2 pigz
1562 lfsmake2 tmux
1563 lfsmake2 perl-Text-CSV_XS
09b09b85 1564 lfsmake2 lua
489145db
MT
1565 lfsmake2 haproxy
1566 lfsmake2 ipset
489145db
MT
1567 lfsmake2 dnsdist
1568 lfsmake2 bird
8c855a58 1569 lfsmake2 libyang
1a7db134 1570 lfsmake2 frr
489145db
MT
1571 lfsmake2 dmidecode
1572 lfsmake2 mcelog
489145db
MT
1573 lfsmake2 libpciaccess
1574 lfsmake2 libyajl
1575 lfsmake2 libvirt
42fca290 1576 lfsmake2 libtalloc
489145db
MT
1577 lfsmake2 freeradius
1578 lfsmake2 perl-common-sense
1579 lfsmake2 perl-inotify2
1580 lfsmake2 perl-Net-IP
0d6cc79d 1581 lfsmake2 wio
773caa66 1582 lfsmake2 iftop
ddcd60f7 1583 lfsmake2 mdns-repeater
429af178 1584 lfsmake2 i2c-tools
4e9000b4 1585 lfsmake2 nss-myhostname
014b235a 1586 lfsmake2 dehydrated
c708fa15 1587 lfsmake2 shairport-sync
46114d79 1588 lfsmake2 borgbackup
50483167 1589 lfsmake2 lmdb
2397e513 1590 lfsmake2 knot
e1982c69 1591 lfsmake2 spectre-meltdown-checker
06fc6170 1592 lfsmake2 zabbix_agentd
82d176d3 1593 lfsmake2 flashrom
2aca6aa0 1594 lfsmake2 firmware-update
ffcef39d 1595 lfsmake2 tshark
9875e9f2 1596 lfsmake2 speedtest-cli
0db643ce 1597 lfsmake2 rfkill
44cc9a3d 1598 lfsmake2 amazon-ssm-agent
d938509e 1599 lfsmake2 libloc
4d275bcd 1600 lfsmake2 ncdu
76c5f3e0 1601 lfsmake2 lshw
68fbcc0e 1602 lfsmake2 socat
7300386b
AB
1603 lfsmake2 libcdada
1604 lfsmake2 pmacct
2b591415 1605 lfsmake2 squid-asnbl
df0635ab 1606 lfsmake2 qemu-ga
d0817963 1607}
df5e82b3
MT
1608
1609buildinstaller() {
1610 # Run installer scripts one by one
ebaecf2c 1611 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1612 export LOGFILE
489145db
MT
1613 lfsmake2 memtest
1614 lfsmake2 installer
ce9264a1
AF
1615 # use toolchain bash for chroot to strip
1616 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1617}
1618
1619buildpackages() {
ebaecf2c 1620 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1621 export LOGFILE
1622 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1623
df5e82b3
MT
1624
1625 # Generating list of packages used
dc4ae0b7 1626 print_line "Generating packages list from logs"
df5e82b3 1627 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1628 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1629 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1630 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1631 fi
1632 done
7471f6ab 1633 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1634 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1635 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1636 rm -f $BASEDIR/doc/packages-list
c9673262 1637 # packages-list.txt is ready to be displayed for wiki page
f9783277 1638 print_status DONE
4b06f504
MT
1639
1640 # Update changelog
e49f7f0d 1641 cd $BASEDIR
c43b07fd
AF
1642 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1643 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1644 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1645
9607771a 1646 # Create images for install
489145db 1647 lfsmake2 cdrom
bada0832 1648
4dc82852 1649 # Check if there is a loop device for building in virtual environments
841663e7
MT
1650 modprobe loop 2>/dev/null
1651 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1652 lfsmake2 flash-images
4dc82852 1653 fi
c9673262 1654
c4dd9dfc 1655 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1656
0d909a4a 1657 ipfirepackages
e67a57fe 1658
b307417f 1659 cd $BASEDIR
744a04ea 1660
aafdd71b
AF
1661 # remove not useable iso on armv6l (needed to build flash images)
1662 [ "${BUILD_ARCH}" = "armv6l" ] && rm -rf *.iso
744a04ea 1663
5336aaa6 1664 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
b307417f
AF
1665 md5sum $i > $i.md5
1666 done
1667 cd $PWD
1668
e67a57fe
MT
1669 # Cleanup
1670 stdumount
1671 rm -rf $BASEDIR/build/tmp/*
1672
e67a57fe 1673 cd $PWD
e67a57fe
MT
1674}
1675
1676ipfirepackages() {
489145db 1677 lfsmake2 core-updates
5596077b
MT
1678
1679 local i
dc7d6b20 1680 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1681 i=$(basename ${i})
453b418b
MT
1682 if [ -e $BASEDIR/lfs/$i ]; then
1683 ipfiredist $i
1684 else
1685 echo -n $i
f9783277 1686 print_status SKIP
453b418b 1687 fi
fe7fe395 1688 done
78331e30 1689 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1690 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1691 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1692}
1693
bcb9dc13
MT
1694while [ $# -gt 0 ]; do
1695 case "${1}" in
1696 --target=*)
c2e810de 1697 configure_build "${1#--target=}"
bcb9dc13
MT
1698 ;;
1699 -*)
1700 exiterror "Unknown configuration option: ${1}"
1701 ;;
1702 *)
1703 # Found a command, so exit options parsing.
1704 break
1705 ;;
1706 esac
1707 shift
1708done
1709
df5e82b3
MT
1710# See what we're supposed to do
1711case "$1" in
1712build)
f9783277
MT
1713 START_TIME=$(now)
1714
1715 # Clear screen
1716 ${INTERACTIVE} && clear
1717
d66e6fa8 1718 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
df5e82b3 1719 #only restore on a clean disk
6c4cc7ea 1720 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1721 if [ ! -n "$PACKAGE" ]; then
f9783277 1722 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1723 prepareenv
1724 buildtoolchain
1725 else
d66e6fa8 1726 PACKAGENAME=${PACKAGE%.tar.zst}
f9783277 1727 print_build_stage "Packaged toolchain compilation"
df5e82b3 1728 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
cec532b4 1729 zstd -d < "${PACKAGE}" | tar x
df5e82b3
MT
1730 prepareenv
1731 else
1732 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1733 fi
1734 fi
1735 else
df5e82b3
MT
1736 prepareenv
1737 fi
5cfe86e6 1738
f9783277 1739 print_build_stage "Building LFS"
df5e82b3 1740 buildbase
15679d9f 1741
f9783277 1742 print_build_stage "Building IPFire"
15679d9f 1743 buildipfire
5cfe86e6 1744
f9783277 1745 print_build_stage "Building installer"
df5e82b3 1746 buildinstaller
15679d9f 1747
f9783277 1748 print_build_stage "Building packages"
df5e82b3 1749 buildpackages
7a5ed24e 1750
f9783277 1751 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1752
1753 cd $BASEDIR
7a5ed24e 1754 tools/checknewlog.pl
e0c923f4 1755 tools/checkrootfiles
b307417f 1756 cd $PWD
a23731d1 1757
f9783277 1758 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1759 ;;
1760shell)
1761 # enter a shell inside LFS chroot
1762 # may be used to changed kernel settings
1763 prepareenv
1764 entershell
1765 ;;
df5e82b3 1766clean)
f9783277
MT
1767 print_line "Cleaning build directory..."
1768
df5e82b3
MT
1769 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1770 $LOSETUP -d $i 2>/dev/null
1771 done
b0c37190
MT
1772 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1773 # umount $i
1774 #done
df5e82b3
MT
1775 stdumount
1776 for i in `seq 0 7`; do
69a6ec55 1777 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1778 umount /dev/loop${i} 2>/dev/null;
1779 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1780 fi;
df5e82b3
MT
1781 done
1782 rm -rf $BASEDIR/build
1783 rm -rf $BASEDIR/cdrom
f9315063 1784 rm -rf $BASEDIR/packages
ebaecf2c 1785 rm -rf $BASEDIR/log
6c4cc7ea
MT
1786 if [ -h "${TOOLS_DIR}" ]; then
1787 rm -f "${TOOLS_DIR}"
df5e82b3 1788 fi
b307417f 1789 rm -f $BASEDIR/ipfire-*
f9783277 1790 print_status DONE
df5e82b3 1791 ;;
4e432799
MT
1792docker)
1793 # Build the docker image if it does not exist, yet
1794 if ! docker images -a | grep -q ^ipfire-builder; then
1795 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1796 print_status DONE
1797 else
1798 print_status FAIL
1799 exit 1
1800 fi
1801 fi
1802
1803 # Run the container and enter a shell
1804 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1805 ;;
c3db995c 1806downloadsrc)
df5e82b3
MT
1807 if [ ! -d $BASEDIR/cache ]; then
1808 mkdir $BASEDIR/cache
1809 fi
ebaecf2c 1810 mkdir -p $BASEDIR/log
857d9bf2 1811 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1812 FINISHED=0
1813 cd $BASEDIR/lfs
1814 for c in `seq $MAX_RETRIES`; do
1815 if (( FINISHED==1 )); then
1816 break
1817 fi
1818 FINISHED=1
1819 cd $BASEDIR/lfs
1820 for i in *; do
1821 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1822 lfsmakecommoncheck ${i} || continue
1823
dc7d6b20 1824 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1825 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1826 if [ $? -ne 0 ]; then
f9783277 1827 print_status FAIL
df5e82b3
MT
1828 FINISHED=0
1829 else
1830 if [ $c -eq 1 ]; then
f9783277 1831 print_status DONE
df5e82b3
MT
1832 fi
1833 fi
1834 fi
1835 done
1836 done
e22c7973 1837 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1838 ERROR=0
1839 for i in *; do
1840 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1841 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1842 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1843 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1844 if [ $? -ne 0 ]; then
e22c7973 1845 echo -ne "MD5 difference in lfs/$i"
f9783277 1846 print_status FAIL
df5e82b3
MT
1847 ERROR=1
1848 fi
1849 fi
1850 done
1851 if [ $ERROR -eq 0 ]; then
e22c7973 1852 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1853 print_status DONE
e22c7973
MT
1854 else
1855 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1856 print_status FAIL
df5e82b3 1857 fi
e22c7973 1858 cd - >/dev/null 2>&1
df5e82b3 1859 ;;
df5e82b3 1860toolchain)
f9783277
MT
1861 # Clear screen
1862 ${INTERACTIVE} && clear
1863
df5e82b3 1864 prepareenv
f3b7cf47 1865 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1866 buildtoolchain
f74072a2 1867 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1868 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
d66e6fa8
MT
1869 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1870 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1871 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
dc7d6b20 1872 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1873 stdumount
1874 ;;
1875gettoolchain)
df5e82b3 1876 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1877 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
d66e6fa8 1878 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
5bd13f01 1879 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1880 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1881 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1882 cd $BASEDIR/cache/toolchains
d66e6fa8 1883 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1884 if [ $? -ne 0 ]; then
dc7d6b20 1885 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1886 else
5d099c0e 1887 if [ "`md5sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1888 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1889 else
1890 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1891 fi
40a4ea4c 1892 fi
712d859c
MT
1893 else
1894 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1895 fi
1896 ;;
15679d9f 1897uploadsrc)
661d9388
CS
1898 if [ -z $IPFIRE_USER ]; then
1899 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1900 print_status FAIL
661d9388
CS
1901 exit 1
1902 fi
ae23a606 1903
dbd455ef
MT
1904 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
1905
1906 rsync \
1907 --recursive \
1908 --update \
1909 --ignore-existing \
1910 --progress \
1911 --human-readable \
1912 --exclude="toolchains/" \
1913 "${BASEDIR}/cache/" \
1914 "${IPFIRE_USER}@${URL_SOURCE}"
661d9388 1915
15679d9f 1916 exit 0
0eab8e84 1917 ;;
bf7c473f 1918lang)
69a6ec55
MT
1919 echo -ne "Checking the translations for missing or obsolete strings..."
1920 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1921 $BASEDIR/tools/sort_strings.pl en
1922 $BASEDIR/tools/sort_strings.pl de
1923 $BASEDIR/tools/sort_strings.pl fr
1924 $BASEDIR/tools/sort_strings.pl es
1925 $BASEDIR/tools/sort_strings.pl pl
1926 $BASEDIR/tools/sort_strings.pl ru
1927 $BASEDIR/tools/sort_strings.pl nl
1928 $BASEDIR/tools/sort_strings.pl tr
1929 $BASEDIR/tools/sort_strings.pl it
1930 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1931 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1932 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1933 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
72c8478e 1934 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
69a6ec55
MT
1935 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1936 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1937 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1938 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1939 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1940 print_status DONE
69a6ec55
MT
1941
1942 echo -ne "Updating language lists..."
1943 update_language_list ${BASEDIR}/src/installer/po
1944 update_language_list ${BASEDIR}/src/setup/po
f9783277 1945 print_status DONE
bf7c473f 1946 ;;
1fb7f56e
MT
1947update-contributors)
1948 update_contributors
1949 ;;
ba137dd8
MT
1950find-dependencies)
1951 shift
1952 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
1953 ;;
4edcd4b2
LAH
1954check-manualpages)
1955 echo "Checking the manual pages for broken links..."
1956
1957 chmod 755 $BASEDIR/tools/check_manualpages.pl
1958 if $BASEDIR/tools/check_manualpages.pl; then
1959 print_status DONE
1960 else
1961 print_status FAIL
1962 fi
1963 ;;
6b8cff41 1964*)
a55f90e9 1965 echo "Usage: $0 [OPTIONS] {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies|check-manualpages}"
6b8cff41
MT
1966 cat doc/make.sh-usage
1967 ;;
3ea75603 1968esac
98329972 1969